Program HeapTest;  {$APPTYPE CONSOLE}   // 1999 by Matthias Withopf / c't 10/99

Uses
  DbgHeap,
  SysUtils;

Var
  p1,p2 : PChar;
  s     : String;
Begin
  // Ohne DbgHeap luft das Programm scheinbar fehlerfrei bis zum Ende.
  // Auch BoundsChecker (5.02) erkennt nicht einmal die Hlfte der Fehler (2+6+7)
  s := 'HeapTest!';       // fr den String wird Speicher angefordert:
                          // 8 + Lnge + 1 = 18 Bytes
  WriteLn(s);
  If s = 'HeapTest!' then // FEHLER 1: interne Funktion zum Stringvergleich (@LStrCmp)
    ;                     //           greift ber das Stringende hinaus zu, wenn die
                          //           Stringlnge kein Vielfaches von 4 ist!
  GetMem(p1,5);           // Speicher fr 5 Zeichen anfordern
  StrCopy(p1,'Hallo');    // FEHLER 2: braucht Speicher fr 0-Byte-Terminator
                          //           Schreibzugriff ber Blockende hinaus!
  p1[4] := #0;
  p1[5] := '!';           // FEHLER 3: Schreibzugriff ber Blockende hinaus!
  FreeMem(p1);
  GetMem(p2,13);
  p2[0] := 'A';           // FEHLER 4: Speicher wird nicht freigegeben
  p1[0] := '?';           // FEHLER 5: Zugriff auf bereits freigegebenen Speicher!
  FreeMem(p1);            // FEHLER 6: Speicherblock wird doppelt freigegeben!
                          // FEHLER 7: Speicher fr Stringvariable s (17 Bytes) wird
                          //           nicht freigegeben (der Compiler sollte
                          //           eigentlich geeigneten Code erzeugen...)
End.
